Subject: Re: [Fecframe] Question from FECFRAME about RTP Payload Format Parameters

From: Colin Perkins <[email-masked]>
Date: Tue, 9 Dec 2008 18:18:21 +0000

Mark,

RTP payload formats are named using media subtypes, which have  
associated media subtype parameters.  Those parameters are conveyed  
in SDP using the "a=fmtp:" line.  If you're designing an RTP payload  
format, it should use that standard mechanism for naming the format  
and conveying its parameters. The FEC-scheme-specific information  
would be one of those parameters, I assume, carried in the "a=fmtp:"  
line.

Colin

On 17 Nov 2008, at 18:21, Mark Watson wrote:
> All,
>
> The following question was discussed at FECFRAME and it was  
> suggested to take this to AVT as well.
>
> FECFRAME has defined an SDP attribute to carry information about  
> FEC repair flows which is specific to the particular FEC Scheme  
> being used. This attribute contains an ‘opaque’ container which  
> contains FEC-Scheme-specific information that is supposed to be  
> handled by the FEC scheme. This is a generic mechanism which could  
> be applied whether the FEC repair data is carried over RTP or  
> directly over UDP.
>
> In the case that RTP is used for repair data, then RTP Payload  
> Format must be defined for the FEC Scheme in the usual way. In this  
> context we have the possibility to define RTP Payload Format  
> parameters which would then be carried in the a=fmtp SDP parameter.
>
> The question under discussion is whether we should define RTP  
> Payload Format parameters at all, or whether we can use the FEC  
> Framework SDP attribute in the RTP context just as it is used for  
> repair data carried over UDP.
>
> The advantage of defining RTP Payload Format Parameters is that  
> this is the standard and recognised way of communicating parameters  
> which are needed to process data carried in an RTP Payload.
>
> The disadvantage of defining RTP Payload Format Parameters is that  
> we essentially end up with two mechanisms for carrying the same  
> information and this causes additional implementation work and  
> potential for confusion about which mechanism should be used when.
>
> An example of SDP using the FECFRAME attribute would be:
>
>        v=0
>         o=ali 1122334455 1122334466 IN IP4 fec.example.com
>         t=0 0
>         a=group:FEC S1 R1
>         m=video 30000 RTP/AVP 100
>         c=IN IP4 224.1.1.1/127
>         a=rtpmap:100 MP2T/90000
>         a=mid:S1
>         m=application 30000 RTP/AVP 110
>         c=IN IP4 224.1.2.1/127
>         a=rtpmap:110 raptorfec/90000
>         a=fec-repair-flow: encoding-id=0; fssi=4W5S6X
>         a=repair-window: 200 ms
>         a=mid:R1
>
> And an example using RTP Payload Format Parameters would be:
>
>         v=0
>         o=ali 1122334455 1122334466 IN IP4 fec.example.com
>         t=0 0
>         a=group:FEC S1 R1
>         m=video 30000 RTP/AVP 100
>         c=IN IP4 224.1.1.1/127
>         a=rtpmap:100 MP2T/90000
>         a=mid:S1
>         m=application 30000 RTP/AVP 110
>         c=IN IP4 224.1.2.1/127
>         a=rtpmap:110 raptorfec/90000
>         a=fmtp:110 sbl=1231; symbol-size=96; repair-window=200ms
>         a=mid:R1
>
> FECFRAME would like to hear opinions from AVT on this question.
>
> Regards,
>
> Mark Watson
> _______________________________________________
> Fecframe mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/fecframe

-- 
Colin Perkins
http://csperkins.org/

_______________________________________________
Fecframe mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/fecframe

---

From: Mark Watson <[email-masked]>
Date: Tue, 09 Dec 2008 14:07:23 -0800

Roni, Colin,

I guess I should clarify that the FECFRAME SDP attributes will be defined in
any case because they are needed for flows which are signaled in SDP but
which do not use RTP.

In the case that RTP is used, then, we have the choice of using the FECFRAME
attributes or using RTP Payload Format parameters.

To be honest, my feeling is that it is not very clean either way: either we
break the RTP convention (or rule?) that all the required information to
interpret the payload is available in the RTP Payload Format Parameters or
we have duplicate ways to signal the same information.

Colin¹s mail suggests we could define an RTP Payload Format parameter to
carry the scheme-specific information in the same way that the FECFRAME SDP
attribute does (as a base64-encoded octet string) and then all FECFRAME RTP
Payload Formats could use the same parameter. But I wonder whether the
advantage of this is marginal compared to the advantage of the parameters
being clearly visible in the SDP.

Regards,

Mark

On 12/9/08 12:03 PM, "Roni Even" <[email-masked]> wrote:

> Hi,
> Just to emphasis Colin email.
> If raptorfec is a the payload format you want to standardize than it can have
> parameters specified for this payload type and conveyed in fmtp line.
>  
> The first example is using the generic SDP parameters approach and you will
> need to specify the semantics for session and media level usage of the
> parameters. I noticed that it is different from
> draft-begen-fecframe-sdp-elements-00. This solution will need to register the
> parameter and I assume they will relate to a registered scheme id as specified
> in the begen draft.
>  
> Both will work and it depends what approach you are using.
>  
> Roni Even
>  
>  
>  
> 
> From: [email-masked] [mailto:[email-masked]] On Behalf Of Colin
> Perkins
> Sent: Tuesday, December 09, 2008 8:18 PM
> To: Mark Watson
> Cc: [email-masked]; [email-masked]
> Subject: Re: [AVT] [Fecframe] Question from FECFRAME about RTP Payload Format
> Parameters
>  
> Mark,
> 
>  
> 
> RTP payload formats are named using media subtypes, which have associated
> media subtype parameters.  Those parameters are conveyed in SDP using the
> "a=fmtp:" line.  If you're designing an RTP payload format, it should use that
> standard mechanism for naming the format and conveying its parameters. The
> FEC-scheme-specific information would be one of those parameters, I assume,
> carried in the "a=fmtp:" line.
> 
>  
> 
> Colin
> 
>  
> 
>  
> 
>  
> 
>> The following question was discussed at FECFRAME and it was suggested to take
>> this to AVT as well.
>> 
>> FECFRAME has defined an SDP attribute to carry information about FEC repair
>> flows which is specific to the particular FEC Scheme being used. This
>> attribute contains an Œopaque¹ container which contains FEC-Scheme-specific
>> information that is supposed to be handled by the FEC scheme. This is a
>> generic mechanism which could be applied whether the FEC repair data is
>> carried over RTP or directly over UDP.
>> 
>> In the case that RTP is used for repair data, then RTP Payload Format must be
>> defined for the FEC Scheme in the usual way. In this context we have the
>> possibility to define RTP Payload Format parameters which would then be
>> carried in the a=fmtp SDP parameter.
>> 
>> The question under discussion is whether we should define RTP Payload Format
>> parameters at all, or whether we can use the FEC Framework SDP attribute in
>> the RTP context just as it is used for repair data carried over UDP.
>> 
>> The advantage of defining RTP Payload Format Parameters is that this is the
>> standard and recognised way of communicating parameters which are needed to
>> process data carried in an RTP Payload.
>> 
>> The disadvantage of defining RTP Payload Format Parameters is that we
>> essentially end up with two mechanisms for carrying the same information and
>> this causes additional implementation work and potential for confusion about
>> which mechanism should be used when.
>>